import Qid
import Errors


class ByteIO :
	def __init__(self, source) : 
		self.debug = 0
		self.read = source.read
		self.write = source.write
		try :
			self.getvalue = source.getvalue
		except :
			pass
		
		self.io_bytes_read = 0
		self.io_bytes_written = 0
		
	def print_byte(self, rw, x) :
	
		if self.debug == 0 : return
		
		if rw == 'w' : return
		
		o = ord(x)
		if o < 32 or o > 255 :
			ch = ' '
		else :
			ch = x
			
		str = "%s %02d %02d %c %s" % (rw, self.io_bytes_read, o, ch, hex(o))
		
		Errors.stderr(str)
		
	def GDATA(self, count) :
		data = self.read(count)
		self.io_bytes_read += count
		return data
		
	def PDATA(self, data) :
		self.write(data)
		self.io_bytes_written += len(data)
		
	def GBIT8(self) :
		a = self.read(1)
		self.io_bytes_read += 1
		
	#	for debugging the input stream
		self.print_byte('r', a)
		
		return ord(a)
		
	def GBIT16(self) :
		(a, b) = self.read(2)
		self.io_bytes_read += 1
		self.print_byte('r', a)
		
		self.io_bytes_read += 1
		self.print_byte('r', b)
	#	for debugging the input stream
		
		return ord(a)  | ord(b) << 8

	def GBIT32(self) :
		a = long(self.GBIT16())
		b = long(self.GBIT16())
		a |= b << 16
		return a

	def gstring(self) :
		length = self.GBIT16()
		txt = self.GDATA(length)
		real_length = len(txt)
	# for debugging
		for i in range(0, real_length) :
			self.print_byte('r', txt[i])
		
		return txt
	
	def pstring(self, txt) :
		length = len(txt)
		self.PBIT16(length)
		self.PDATA(txt)
		
	# for debugging
		for i in range(0, length) :
			self.print_byte('w', txt[i])
			self.io_bytes_written += 1

	def GBIT64(self) :
		a = self.GBIT32()
		b = self.GBIT32()
		a |= b << 32
		return a 

	def PBIT8(self, v) :
		c = chr(v & 255)
		self.write(c)
		
	#	for debugging the output stream	
		self.print_byte('w', c)
				
		self.io_bytes_written += 1

		return c
	
	def PBIT16(self, v) :
		self.PBIT8(v)
		self.PBIT8(v >> 8)
		
	def PBIT32(self, v) :
		self.PBIT16(v)
		self.PBIT16(v >> 16	)
		
	def PBIT64(self, v) :
		self.PBIT32(v)
		self.PBIT32(v >> 32)	

	def pqid(self, qid) :
		if qid :
			self.PBIT8(qid.type)
			self.PBIT32(qid.vers)
			self.PBIT64(qid.path)
	

	def gqid(self) :
		qid = Qid.Qid()
		qid.type = self.GBIT8()
		qid.vers = self.GBIT32()
		qid.path = self.GBIT64()
		
		return qid