import os
import os.path
import Errors
import sys
import Dir
import stat
import User
import Qid



fid_activity = {}
defaultuser = 'nobody'

def stderr(txt) :
	sys.stderr.write(txt + "\n")
	sys.stderr.flush()

def lookup_fid(fid) :
	global fid_activity

	if fid_activity.has_key(fid) :
		return fid_activity[fid] 

	return None


def newfid(fid) :
	global fid_activity

	if lookup_fid(fid) :
		raise Errors.Efidactive;

	f = Fid(fid)
	f.fd = -1
	f.omode = -1

	fid_activity[fid] = f

	return f

def freefid(fid) :
	global fid_activity

	f = lookup_fid(fid.fid)
	if f :
		f.close()
		del fid_activity[f.fid]

def oldfid(fid, auth=0) :
	global fid_activity	

	f = lookup_fid(fid)
	if not f :
		raise Errors.Ebadfid

## no authentication
#	if auth != -1 and f.auth != auth :
#		raise Errors.Ebadfid
	

#	if not f.auth :
#		if not f.userchange()
#			return None

	return f


class Fid :
	fid  = None # int
	path = None  # char*
	st = None  # struct stat
	u = None  # User*
	omode = None  # int
	dir = None  # DIR*
	diroffset = None  # int
	fd = None  # int
	dirent = None  # dirent*
	next = None  # Fid*
	prev = None  # Fid*
	authmagic = None  # void*


	def __init__(self, fid) :
		self.fid = fid
		self.auth = 0

	def stat(self) :
		try :
			self.st = os.stat(self.path)
			return self.st
		except :
			return None

	def set_u(self, user) :
		self.u = user

	def close(self) :
		pass
		# how quaint

	def _print(self) :
		stderr("Fid : %d  path : \"%s\" isdir: %d  stats: %d" % ( self.fid, self.path, self.isdir(), self.stat() != None))
		


	def userchange(self) :
		global defaultuser
	
		if defaultuser :
			return 1

		if os.setreuid(0, 0) :
			stderr('Fid - userchange failed to setreuid(0,0)')

		raise "didn't get this far"

	def isdir(self) :
		return os.path.isdir(self.path)

	def stat2dir(self) :
		if not self.st :
			if not self.stat() :
				return None

		d = Dir.Dir()
		d.type = 0
		d.dev = 0
		d.qid = self.stat2qid()
		d.mode = self.plan9_mode()
		d.atime = self.st.st_atime
		d.mtime = self.st.st_mtime
		d.length = self.st.st_size

		u = User.uid2user(self.st.st_uid)
		if u and u.name != '' :
			d.uid = u.name
		else :
			d.uid = '???'

		g = User.gid2user(self.st.st_gid)
		if g and g.name != '' :
			d.gid = g.name
		else :
			d.gid = '???'
		d.muid = ''
		d.name = os.path.basename(self.path)

		return d

	def stat2qid(self) :
		if not self.st :
			if not self.stat() :
				return None

		q = Qid.Qid()

		q.make_from_fid_stat(self.st)

		return q



	def plan9_mode(self) :
		if not self.st :
			if not self.stat() :
				return None

		mode = 0L

		if stat.S_ISDIR(self.st[0]) :
			mode = mode | Qid.QTDIR

		mode = mode << 24
		mode = mode | ( self.st.st_mode & 0777 )

		return mode



		
